clear all
close all
%_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
% INPUT : nothing     
% OUTPUT : water point... 
%          Qw    : World coordinate pointset (og),
%          Qw_Oc : Camera coordinate pointset
% (1)create (or load) camera, virtual camera 
% (2)create water point Qw, Qw_Oc
%_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

%_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
% (1)create (or load) camera, virtual camera
%_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
 %--- please set params ---------------
  f = 5.0;      % focal lengh 
 n2 = 1.49;     % refractive index of housing
 n3 = 1.33;     % refractive index of water
 dg = 30;       % housing thickness
 da = 150;      % distance cam-housing
  
 % create real camera (for Intrinsic)
 CCD_SIZE = 4.8;                            %
 pixelF   = f*1280/CCD_SIZE;                %
 intrinsic = [pixelF,0,0;0,pixelF,0;0,0,1]; % for example
 realcam = Camera(intrinsic);               % real camera C'
 % rotation
 phi_u = double(pi/18);
 Rv2c = [1 0 0; 0 cos(-phi_u) -sin(-phi_u); 0 sin(-phi_u) cos(-phi_u)];
 
 %--------------------------------------
 %_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
 % create varifocal camera 
 vcamSim =  VariCamera([f, da, dg], [1, n2, n3]);
 vcamSim.cam = realcam;
 % coordinate transformation params
 vcamSim.W2V_R = [1,0,0;0,1,0;0,0,1];   % by definition 
 vcamSim.W2V_t = [0;0; da+dg];          % 
 vcamSim.V2C_R = Rv2c;   
 vcamSim.getC2V2W;
 vcamSim.updateBWC;
 vcamSim.getLookUp(4000, 4.8);

%_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
% (2)create water point Qw, Qw_Oc
%_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

 setRow = 10; 
 setCol = 10;
 setZ   = 4;
 setNUM = setRow *setCol * setZ;    % num of water point
 p_xqw = linspace(-150, 150, setRow);   
 p_yqw = linspace(-80, 80, setCol);
 p_zqw = linspace(100, 500,  setZ);
 
 for k=1:setCol
    xyqw(:,(k-1)*setRow+1:k*setRow) = [p_xqw; p_yqw(k)*ones(1,setRow)];
 end
   Qw = [];
 for k=1:setZ
   Qw = [Qw, [xyqw; p_zqw(k)*ones(1, setRow *setCol)]];
 end
 
 % Create Qw_Oc
 Qw_Oc = vcamSim.W2C_R * Qw + vcamSim.W2C_t*ones(size(Qw(1,:)));
 
 save('./data/vcamSim.mat','vcamSim');
 save('./data/sampleQw.mat','Qw','Qw_Oc');
 
 
 
 